diff --git a/lib/librte_acl/rte_acl_version.map b/lib/librte_acl/rte_acl_version.map
index b09370a104ed..f35be2b91bfd 100644
--- a/lib/librte_acl/rte_acl_version.map
+++ b/lib/librte_acl/rte_acl_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_bbdev/rte_bbdev_version.map b/lib/librte_bbdev/rte_bbdev_version.map
index 3624eb1cb402..eaeb7a5fa5fe 100644
--- a/lib/librte_bbdev/rte_bbdev_version.map
+++ b/lib/librte_bbdev/rte_bbdev_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 EXPERIMENTAL {
 	global:
 
diff --git a/lib/librte_bitratestats/rte_bitratestats_version.map b/lib/librte_bitratestats/rte_bitratestats_version.map
index fe7454452d4a..601fe228088e 100644
--- a/lib/librte_bitratestats/rte_bitratestats_version.map
+++ b/lib/librte_bitratestats/rte_bitratestats_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_17.05 {
 	global:
 
diff --git a/lib/librte_bpf/rte_bpf_version.map b/lib/librte_bpf/rte_bpf_version.map
index a203e088eab8..ff24ba2958a7 100644
--- a/lib/librte_bpf/rte_bpf_version.map
+++ b/lib/librte_bpf/rte_bpf_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 EXPERIMENTAL {
 	global:
 
diff --git a/lib/librte_cfgfile/rte_cfgfile_version.map b/lib/librte_cfgfile/rte_cfgfile_version.map
index a0a11cea8df4..3df4f1443ecc 100644
--- a/lib/librte_cfgfile/rte_cfgfile_version.map
+++ b/lib/librte_cfgfile/rte_cfgfile_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_cmdline/rte_cmdline_version.map b/lib/librte_cmdline/rte_cmdline_version.map
index 04bcb387f2a1..3704bb5befdb 100644
--- a/lib/librte_cmdline/rte_cmdline_version.map
+++ b/lib/librte_cmdline/rte_cmdline_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_compressdev/rte_compressdev_version.map b/lib/librte_compressdev/rte_compressdev_version.map
index e2a108b6509f..af567fe2458d 100644
--- a/lib/librte_compressdev/rte_compressdev_version.map
+++ b/lib/librte_compressdev/rte_compressdev_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 EXPERIMENTAL {
 	global:
 
diff --git a/lib/librte_cryptodev/rte_cryptodev_version.map b/lib/librte_cryptodev/rte_cryptodev_version.map
index 3deb265ac270..89d9ef88b46b 100644
--- a/lib/librte_cryptodev/rte_cryptodev_version.map
+++ b/lib/librte_cryptodev/rte_cryptodev_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_16.04 {
 	global:
 
diff --git a/lib/librte_distributor/rte_distributor_version.map b/lib/librte_distributor/rte_distributor_version.map
index 3a285b394eb2..2a30171b3685 100644
--- a/lib/librte_distributor/rte_distributor_version.map
+++ b/lib/librte_distributor/rte_distributor_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_eal/rte_eal_version.map b/lib/librte_eal/rte_eal_version.map
index 7cbf82d37b0a..110ab55a9578 100644
--- a/lib/librte_eal/rte_eal_version.map
+++ b/lib/librte_eal/rte_eal_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_efd/rte_efd_version.map b/lib/librte_efd/rte_efd_version.map
index ae60a6417802..0d192403a859 100644
--- a/lib/librte_efd/rte_efd_version.map
+++ b/lib/librte_efd/rte_efd_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_17.02 {
 	global:
 
diff --git a/lib/librte_ethdev/rte_ethdev_version.map b/lib/librte_ethdev/rte_ethdev_version.map
index 6df42a47b89d..a25a6ed62b85 100644
--- a/lib/librte_ethdev/rte_ethdev_version.map
+++ b/lib/librte_ethdev/rte_ethdev_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.2 {
 	global:
 
diff --git a/lib/librte_eventdev/rte_eventdev_version.map b/lib/librte_eventdev/rte_eventdev_version.map
index 76b3021d3aea..d1fc52410e55 100644
--- a/lib/librte_eventdev/rte_eventdev_version.map
+++ b/lib/librte_eventdev/rte_eventdev_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_17.05 {
 	global:
 
diff --git a/lib/librte_flow_classify/rte_flow_classify_version.map b/lib/librte_flow_classify/rte_flow_classify_version.map
index 49bc25c6a087..42dc38cde68e 100644
--- a/lib/librte_flow_classify/rte_flow_classify_version.map
+++ b/lib/librte_flow_classify/rte_flow_classify_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 EXPERIMENTAL {
 	global:
 
diff --git a/lib/librte_gro/rte_gro_version.map b/lib/librte_gro/rte_gro_version.map
index 1606b6dc72ee..13e588353261 100644
--- a/lib/librte_gro/rte_gro_version.map
+++ b/lib/librte_gro/rte_gro_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_17.08 {
 	global:
 
diff --git a/lib/librte_gso/rte_gso_version.map b/lib/librte_gso/rte_gso_version.map
index e1fd453edbc4..5bf68db12b80 100644
--- a/lib/librte_gso/rte_gso_version.map
+++ b/lib/librte_gso/rte_gso_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_17.11 {
 	global:
 
diff --git a/lib/librte_hash/rte_hash_version.map b/lib/librte_hash/rte_hash_version.map
index 734ae28b0408..21f33e4453a3 100644
--- a/lib/librte_hash/rte_hash_version.map
+++ b/lib/librte_hash/rte_hash_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_ip_frag/rte_ip_frag_version.map b/lib/librte_ip_frag/rte_ip_frag_version.map
index a193007c61b3..37587fc26476 100644
--- a/lib/librte_ip_frag/rte_ip_frag_version.map
+++ b/lib/librte_ip_frag/rte_ip_frag_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_ipsec/rte_ipsec_version.map b/lib/librte_ipsec/rte_ipsec_version.map
index ee9f1961b0ba..2ffab2ad900f 100644
--- a/lib/librte_ipsec/rte_ipsec_version.map
+++ b/lib/librte_ipsec/rte_ipsec_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 EXPERIMENTAL {
 	global:
 
diff --git a/lib/librte_jobstats/rte_jobstats_version.map b/lib/librte_jobstats/rte_jobstats_version.map
index f89441438e26..f4d85bc191d4 100644
--- a/lib/librte_jobstats/rte_jobstats_version.map
+++ b/lib/librte_jobstats/rte_jobstats_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_kni/rte_kni_version.map b/lib/librte_kni/rte_kni_version.map
index c877dc6aaa63..e0c1c360f412 100644
--- a/lib/librte_kni/rte_kni_version.map
+++ b/lib/librte_kni/rte_kni_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_kvargs/rte_kvargs_version.map b/lib/librte_kvargs/rte_kvargs_version.map
index 8f4b4e3f8fe2..d20a485bce95 100644
--- a/lib/librte_kvargs/rte_kvargs_version.map
+++ b/lib/librte_kvargs/rte_kvargs_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_latencystats/rte_latencystats_version.map b/lib/librte_latencystats/rte_latencystats_version.map
index ac8403e821dc..a24c347798a8 100644
--- a/lib/librte_latencystats/rte_latencystats_version.map
+++ b/lib/librte_latencystats/rte_latencystats_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_17.05 {
 	global:
 
diff --git a/lib/librte_lpm/rte_lpm_version.map b/lib/librte_lpm/rte_lpm_version.map
index 90beac853d2e..51eff3807e6d 100644
--- a/lib/librte_lpm/rte_lpm_version.map
+++ b/lib/librte_lpm/rte_lpm_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_mbuf/rte_mbuf_version.map b/lib/librte_mbuf/rte_mbuf_version.map
index 2662a37bf674..adfb82fa55de 100644
--- a/lib/librte_mbuf/rte_mbuf_version.map
+++ b/lib/librte_mbuf/rte_mbuf_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_member/rte_member_version.map b/lib/librte_member/rte_member_version.map
index 019e4cd962dc..749b2da28636 100644
--- a/lib/librte_member/rte_member_version.map
+++ b/lib/librte_member/rte_member_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_17.11 {
 	global:
 
diff --git a/lib/librte_mempool/rte_mempool_version.map b/lib/librte_mempool/rte_mempool_version.map
index 17cbca4607c0..c0f7fefffc45 100644
--- a/lib/librte_mempool/rte_mempool_version.map
+++ b/lib/librte_mempool/rte_mempool_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_meter/rte_meter_version.map b/lib/librte_meter/rte_meter_version.map
index 4b460d580378..78f555ce1d0f 100644
--- a/lib/librte_meter/rte_meter_version.map
+++ b/lib/librte_meter/rte_meter_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_metrics/rte_metrics_version.map b/lib/librte_metrics/rte_metrics_version.map
index 6ac99a44a104..f8c6e8199424 100644
--- a/lib/librte_metrics/rte_metrics_version.map
+++ b/lib/librte_metrics/rte_metrics_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_17.05 {
 	global:
 
diff --git a/lib/librte_net/rte_net_version.map b/lib/librte_net/rte_net_version.map
index fffc4a3723bb..355f584808b7 100644
--- a/lib/librte_net/rte_net_version.map
+++ b/lib/librte_net/rte_net_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_16.11 {
 	global:
 	rte_net_get_ptype;
diff --git a/lib/librte_pci/rte_pci_version.map b/lib/librte_pci/rte_pci_version.map
index c0280277bbef..df9a79e5ffe8 100644
--- a/lib/librte_pci/rte_pci_version.map
+++ b/lib/librte_pci/rte_pci_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_17.11 {
 	global:
 
diff --git a/lib/librte_pdump/rte_pdump_version.map b/lib/librte_pdump/rte_pdump_version.map
index 3e744f30123c..60b3e15bff0a 100644
--- a/lib/librte_pdump/rte_pdump_version.map
+++ b/lib/librte_pdump/rte_pdump_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_16.07 {
 	global:
 
diff --git a/lib/librte_pipeline/rte_pipeline_version.map b/lib/librte_pipeline/rte_pipeline_version.map
index 420f065d6e96..3810e16cc068 100644
--- a/lib/librte_pipeline/rte_pipeline_version.map
+++ b/lib/librte_pipeline/rte_pipeline_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_port/rte_port_version.map b/lib/librte_port/rte_port_version.map
index 609bcec3ff85..a3386afd775f 100644
--- a/lib/librte_port/rte_port_version.map
+++ b/lib/librte_port/rte_port_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_power/rte_power_version.map b/lib/librte_power/rte_power_version.map
index 042917360e40..c029e27b5f79 100644
--- a/lib/librte_power/rte_power_version.map
+++ b/lib/librte_power/rte_power_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_rawdev/rte_rawdev_version.map b/lib/librte_rawdev/rte_rawdev_version.map
index b61dbff11c63..afdec3f8a019 100644
--- a/lib/librte_rawdev/rte_rawdev_version.map
+++ b/lib/librte_rawdev/rte_rawdev_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_18.08 {
 	global:
 
diff --git a/lib/librte_rcu/rte_rcu_version.map b/lib/librte_rcu/rte_rcu_version.map
index f8b9ef2abb2a..f19baa864497 100644
--- a/lib/librte_rcu/rte_rcu_version.map
+++ b/lib/librte_rcu/rte_rcu_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 EXPERIMENTAL {
 	global:
 
diff --git a/lib/librte_reorder/rte_reorder_version.map b/lib/librte_reorder/rte_reorder_version.map
index 0a8a54de8340..540959a810aa 100644
--- a/lib/librte_reorder/rte_reorder_version.map
+++ b/lib/librte_reorder/rte_reorder_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_ring/rte_ring_version.map b/lib/librte_ring/rte_ring_version.map
index 510c1386e038..5424572dc76e 100644
--- a/lib/librte_ring/rte_ring_version.map
+++ b/lib/librte_ring/rte_ring_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_sched/rte_sched_version.map b/lib/librte_sched/rte_sched_version.map
index 729588794e7c..3a16e444ec93 100644
--- a/lib/librte_sched/rte_sched_version.map
+++ b/lib/librte_sched/rte_sched_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_security/rte_security_version.map b/lib/librte_security/rte_security_version.map
index 53267bf3cc08..f81aa1403f73 100644
--- a/lib/librte_security/rte_security_version.map
+++ b/lib/librte_security/rte_security_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_18.11 {
 	global:
 
diff --git a/lib/librte_stack/rte_stack_version.map b/lib/librte_stack/rte_stack_version.map
index 6662679c3637..4d2a3f6bc91a 100644
--- a/lib/librte_stack/rte_stack_version.map
+++ b/lib/librte_stack/rte_stack_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 EXPERIMENTAL {
 	global:
 
diff --git a/lib/librte_table/rte_table_version.map b/lib/librte_table/rte_table_version.map
index 6237252bece6..a805d22ac2c7 100644
--- a/lib/librte_table/rte_table_version.map
+++ b/lib/librte_table/rte_table_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_17.11 {
 	global:
 
diff --git a/lib/librte_telemetry/rte_telemetry_version.map b/lib/librte_telemetry/rte_telemetry_version.map
index fa62d7718ce6..c137363bb00f 100644
--- a/lib/librte_telemetry/rte_telemetry_version.map
+++ b/lib/librte_telemetry/rte_telemetry_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 EXPERIMENTAL {
 	global:
 
diff --git a/lib/librte_timer/rte_timer_version.map b/lib/librte_timer/rte_timer_version.map
index 72f75c818134..0845b2aaa7ef 100644
--- a/lib/librte_timer/rte_timer_version.map
+++ b/lib/librte_timer/rte_timer_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 
diff --git a/lib/librte_vhost/rte_vhost_version.map b/lib/librte_vhost/rte_vhost_version.map
index 5f1d4a75c2f8..2df5bcc1e864 100644
--- a/lib/librte_vhost/rte_vhost_version.map
+++ b/lib/librte_vhost/rte_vhost_version.map
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: BSD-3-Clause */
 DPDK_2.0 {
 	global:
 